# PolkuTokenAuthorizer

Welcome to your new gem! In this directory, you'll find the files you need to be able to package up your Ruby library into a gem. Put your Ruby code in the file `lib/polku_token_authorizer`. To experiment with that code, run `bin/console` for an interactive prompt.

TODO: Delete this and the text above, and describe your gem

## Installation

Add this line to your application's Gemfile:

```ruby
gem "polku_token_authorizer", git: "https://gitlab.com/comille-alusta/polku-token-authorizer.git"
```

And then execute:

    $ bundle install

Or install it yourself as:

    $ gem install polku_token_authorizer

## Usage

```ruby
# Generating a token
auth_client = ENV.fetch("OAUTH_CLIENT", 'test')
key = Rails.application.credentials.jwt_private_key
user = nil
token = PolkuTokenAuthorizer::GenerateToken.call(key, auth_client, user)

# Decoding a token
token = request.headers['Authorization']
key = Rails.application.credentials.jwt_public_key
payload = PolkuTokenAuthorizer::AuthorizeRequest.call(key, token)
```


## Development

After checking out the repo, run `bin/setup` to install dependencies. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and the created tag, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/[USERNAME]/polku_token_authorizer.
